'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2015-present Boundless Spatial Inc., http://boundlessgeo.com
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License").
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and limitations
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

/** @module components/map/popup
 * @desc SDK Popup Component
 */

/** Popup Component.
 */
var Popup = function (_React$PureComponent) {
  _inherits(Popup, _React$PureComponent);

  function Popup(props) {
    _classCallCheck(this, Popup);

    var _this = _possibleConstructorReturn(this, (Popup.__proto__ || Object.getPrototypeOf(Popup)).call(this, props));

    _this.close = _this.close.bind(_this);
    _this.state = {
      closed: false
    };
    return _this;
  }

  _createClass(Popup, [{
    key: 'close',
    value: function close(evt) {
      var _this2 = this;

      if (evt) {
        evt.stopPropagation();
      }
      this.setState({ closed: true });
      this.setState({ closed: true }, function () {
        if (_this2.map) {
          _this2.map.updatePopups();
        }
      });
      this.props.onClose();
    }
  }, {
    key: 'setMap',
    value: function setMap(map) {
      this.map = map;
    }
  }, {
    key: 'renderPopup',
    value: function renderPopup(children) {
      var _this3 = this;

      var close_btn = false;
      if (this.props.closeable) {
        close_btn = _react2.default.createElement('i', { tabIndex: 0, role: 'link', onClick: function onClick() {
            _this3.close();
          }, ref: function ref(c) {
            if (c) {
              c.addEventListener('click', _this3.close);
            }
          }, className: 'sdk-popup-closer' });
      }
      if (this.state.closed) {
        return false;
      }
      var className = 'sdk-popup-root';
      if (this.props.className) {
        className = className + ' ' + this.props.className;
      }

      return _react2.default.createElement(
        'div',
        { style: this.props.style, className: className },
        close_btn,
        _react2.default.createElement(
          'div',
          { id: 'sdk-popup-container' },
          _react2.default.Children.only(children)
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return this.renderPopup(this.props.children);
    }
  }]);

  return Popup;
}(_react2.default.PureComponent);

exports.default = Popup;


Popup.propTypes = {
  // this unused prop warning is ignored because the coordinate is
  //  a required prop to rightly render the popup on the map.
  // eslint-disable-next-line
  /** Coordinate where to render the popup in the map. */
  coordinate: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.number), _propTypes2.default.object]).isRequired,
  /** Child component(s). */
  children: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.node, _propTypes2.default.arrayOf(_propTypes2.default.node), _propTypes2.default.arrayOf(_propTypes2.default.element)]),
  /** Should we be able to close the popup? */
  closeable: _propTypes2.default.bool,
  /** onClose callback function. */
  onClose: _propTypes2.default.func,
  /** Style config object. */
  style: _propTypes2.default.object,
  /** Css class name to apply. */
  className: _propTypes2.default.string
};

Popup.defaultProps = {
  children: '',
  closeable: false,
  onClose: function onClose() {
    // do nothing
  }
};