'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Cluster = require('ol/source/Cluster');

var _Cluster2 = _interopRequireDefault(_Cluster);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2015-present Boundless Spatial Inc., http://boundlessgeo.com
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License").
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and limitations
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

/** @module source/cluster
 * @desc ClusterSource class for Boundless SDK,
 *  extends OpenLayers ClusterSource,
 *  {@link http://openlayers.org/en/latest/apidoc/ol.source.Cluster.html}
 */

/** Custom cluster source class.
 */
var SdkClusterSource = function (_ClusterSource) {
  _inherits(SdkClusterSource, _ClusterSource);

  function SdkClusterSource() {
    _classCallCheck(this, SdkClusterSource);

    return _possibleConstructorReturn(this, (SdkClusterSource.__proto__ || Object.getPrototypeOf(SdkClusterSource)).apply(this, arguments));
  }

  _createClass(SdkClusterSource, [{
    key: 'createCluster',


    /** Creates the cluster.
     *
     * @param {Object[]} features Features to be clustered.
     *
     * @returns {Object} The cluster feature.
     */
    value: function createCluster(features) {
      // get the cluster back from the clustering algorithm.
      var cluster = _get(SdkClusterSource.prototype.__proto__ || Object.getPrototypeOf(SdkClusterSource.prototype), 'createCluster', this).call(this, features);
      // add "point_count" to the features
      var n_features = cluster.get('features').length;
      cluster.set('point_count', n_features);
      cluster.set('point_count_abbreviated', n_features);
      return cluster;
    }
  }]);

  return SdkClusterSource;
}(_Cluster2.default);

exports.default = SdkClusterSource;